#!/usr/bin/python3
import sys
import Gpib
import time
import numpy as np

from Adafruit_BME280 import *
env_sensor = BME280(mode=BME280_OSAMPLE_8)
def read_environment():
    global ext_temp, ext_rh, ext_pressure
    ext_temp     = env_sensor.read_temperature() - 1.0
    ext_rh       = env_sensor.read_humidity()
    ext_pressure = env_sensor.read_pressure() / 100

log_name = "dcl_10vdc_5720_8104r_3458a_nlpc100_raw_jul2021.csv"

fluke = Gpib.Gpib(0, 4, timeout=30) # Fluke 5720A, GPIB Address = 5
#fluke.clear()
fluke.write("*IDN?")
print ("Source detected = %s" % fluke.read())

dmm = Gpib.Gpib(0, 22, timeout=30)# Keysight 3458A, GPIB Address = 22
dmm2 = Gpib.Gpib(0, 23, timeout=30)# Keysight 3458A, GPIB Address = 22
#dmm.clear()
dmm.write("*IDN?")
print ("DUT1 detected = %s" % dmm.read())

fluke.write("STBY")
fluke.write("RANGELCK OFF")
fluke.write("OUT 10 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD OFF")
fluke.write("OPER")
time.sleep(2)
print ("SRC configured")
dmm.write("*RST")
print (dmm.read())
dmm.write("D8\r")
print (dmm.read())
dmm.write("RANGE:DC:VOLTAGE 10\r")
print (dmm.read())
dmm.write("F1\n")
print ("DUT configured, starting ACAL")
dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV 10")
dmm2.write("NPLC 100")
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print ("DUT configured, starting ACAL")

#dmm.write("ACAL DCV")
dmm2.write("ACAL DCV")
time.sleep(160)
'''
for vcnt in range (0,2):
    dmm3.write("*TRG;GET;RDG?")
    dmm3.read()
    dmm4.write("READ?") # Get reading
    dmm4.read()
'''
#dmm.write("TARM SGL")
#dmm.read()
#dmm.write("MATH NULL")
#dmm.write("TARM SGL") # Get reading
#dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
dmm2.write("MATH NULL")
dmm2.write("TARM SGL") # Get reading
dmm2.read()

with open(log_name, 'a') as dile:
    dile.write ("date;source;duta;dutb;dutc;dutd;sdev;sdev2;sdev3;sdev4;temp;temp2;ambt;rh;pressure;\r\n")
dile.close()

vcnt = 0 # temporary counter
print ("Log into %s started" % log_name)

for i in range(-109,110,1):
    median = 0.0
    rrsdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    set_value = (float(i) / 10)
    fluke.write("OUT %.7f;OPER" % set_value)
    fluke.write("OPER")
    time.sleep(22)
    for ix in range (0,10):
        dmm.write("READ?")
        time.sleep(3)
        read_environment()
        dmm2.write("TARM SGL")
        txt = dmm.read().decode('utf8')
        txt2 = txt.split("\r")
        print (txt, txt2)
        val = float(txt2[0])
        val2 = float(dmm2.read())
        val3 = set_value #float(dmm3.read())
        val4 = 0#float(dmm4.read())
        array.extend([val])
        array2.extend([val2])
        array3.extend([val3])
        array4.extend([val4])
        if abs(set_value) >= 0.05:
            print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6) ))
        if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
            print ("Smoke escaped, check connections")
            fluke.write("OUT 0 V")
            fluke.write("STBY")
            quit()
        sdev = np.std(array[3:])
        sdev2 = np.std(array2[3:])
        sdev3 = np.std(array3[3:])
        sdev4 = np.std(array4[3:])
        median = np.median(array[3:])
        median2 = np.median(array2[3:])
        median3 = np.median(array3[3:])
        median4 = np.median(array4[3:])
        temp = 35
        temp2 = 23
        if (ix > 3):
            with open(log_name, 'a') as dile:
                dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f;%.3f;%.2f,%.2f\r\n" % (set_value, val, val2, val3, val4, sdev, sdev2, sdev3, sdev4, temp, temp2, ext_temp, ext_rh, ext_pressure)))
            dile.close()
            dev1 = ((median / set_value - 1) * 1e6)
            dev2 = ((median2 /set_value - 1) * 1e6)
            dev3 = ((median3 /set_value - 1) * 1e6)
            dev4 = ((median4 /set_value - 1) * 1e6)
            print("\033[32;1mSRC %.4f \033[33;1mA %.9f, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9f, sdev5 = %.3f uV, med5 = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
    #dmm.write("TEMP?")
    temp = 36#float(dmm.read().decode('utf8').split("\r")[0])
    #dmm2.write("TEMP?")
    temp2 = 23#float(dmm2.read())

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
#dmm.write("RESET")
#dmm2.write("RESET")
